from typing import Generic, List, Optional, Tuple, TypeVar, overload

class IUpdate: ...

class Updater:
    @property
    def current_frequency(self) -> float: ...
    def __init__(self) -> None: ...
    def start(self, update_frequency: int, allow_skips: bool, busy_waiting: bool) -> None: ...
    def stop(self) -> None: ...
    def add(self, obj: IUpdate) -> None: ...
    def remove(self, obj: IUpdate) -> bool: ...

class RaspberryGPIO:
    def __init__(self) -> None: ...
    def pinMode(self, pin: int, mode: int) -> None: ...
    def digitalWrite(self, pin: int, value: int) -> None: ...
    def digitalRead(self, pin: int) -> int: ...

class ISoftwareStepMotorController: ...

class SoftwareStepMotorGPIOController(ISoftwareStepMotorController):
    @property
    def real_pos(self) -> int: ...
    def __init__(self, gpio: RaspberryGPIO, dir_pin: int, step_pin: int, inverse: bool) -> None: ...

class VelPosMotor(IUpdate):
    @property
    def cur_state(self) -> Tuple[int, int, float, float]: ...
    def set_target_pos_vel(self, pos: Tuple[int, float], vel: float) -> None: ...

class SoftwareStepMotor(VelPosMotor):
    def __init__(self, controller: ISoftwareStepMotorController, max_speed: float, kp: float) -> None: ...

class Planner:
    @property
    def duration(self) -> float: ...
    @property
    def delta_pos(self) -> float: ...
    @property
    def start_vel(self) -> float: ...
    @property
    def end_vel(self) -> float: ...
    def get(self, t: float) -> Tuple[float, float]: ...

class PlanState:
    @property
    def pos(self) -> Tuple[int, float]: ...
    @property
    def vel(self) -> float: ...

class CompiledPlanner:
    @property
    def start_time_ns(self) -> int: ...
    @property
    def end_time_ns(self) -> int: ...
    @property
    def start_pos(self) -> Tuple[int, float]: ...
    @property
    def end_pos(self) -> Tuple[int, float]: ...
    @property
    def start_vel(self) -> float: ...
    @property
    def end_vel(self) -> float: ...
    def __init__(self, base_planner: Planner, start_time_ns: int, start_pos: Tuple[int, float]) -> None: ...
    def get(self, cur_time_ns: int) -> PlanState: ...

class PlannerMotorController(IUpdate):
    def __init__(self, motor: VelPosMotor) -> None: ...
    def set_planner(self, planner: CompiledPlanner) -> None: ...

class Event:
    @property
    def notify_time_ns(self) -> int: ...

class EventHandler:
    def __init__(self) -> None: ...
    @overload
    def wait(self) -> Event: ...
    @overload
    def wait(self, timeout: float) -> Optional[Event]: ...
    def push(self, event: Event) -> Optional[Event]: ...

class EventNotifier(IUpdate): ...

T = TypeVar("T")

class PythonEvent(Event, Generic[T]):
    @property
    def obj(self) -> T: ...
    def __init__(self, notify_time_ns: int, obj: T) -> None: ...

class TimeEvent(Event):
    @property
    def event_time_ns(self) -> int: ...
    @property
    def timer_id(self) -> int: ...

class TimeEventNotifier(EventNotifier):
    def __init__(self, core: EventHandler, timer_id: int) -> None: ...
    def set_notify_time_ns(self, time_ns: int) -> None: ...

class GPIOSwitchEvent(Event):
    @property
    def pin(self) -> int: ...
    @property
    def value(self) -> int: ...

class GPIOSwitchEventNotifier(EventNotifier):
    def __init__(self, core: EventHandler, gpio: RaspberryGPIO, pin: int, cooldown_time_ns: int = 0) -> None: ...

class SimplePlanner(Planner):
    def __init__(self, start_vel: float, end_vel: float, duration: float) -> None: ...

class SimpleConstPlanner(Planner):
    def __init__(self, vel: float, duration: float) -> None: ...

class GroupPlanner(Planner):
    def __init__(self, planners: List[Planner]) -> None: ...
